diff -urN vnc-3.3.7/vncserver vnc-3.3.7.readonly/vncserver
--- vnc-3.3.7/vncserver	2007-06-09 22:27:05.000000000 +0200
+++ vnc-3.3.7.readonly/vncserver	2007-06-11 18:53:00.000000000 +0200
@@ -115,6 +115,9 @@
 if ($pixelformat) {
   $opt{'-pixelformat'} = $pixelformat;
 }
+if (!$useVncReadOnlyPort) {
+	$useVncReadOnlyPort="true";
+}
 
 chop($host = `uname -n`);
 
@@ -192,6 +195,16 @@
     }
 }
 
+# Check if we should use a password for readonly port
+
+($z,$z,$mode) = stat("$vncPasswdFile.readonly");
+if ((-e "$vncPasswdFile.readonly") || ($mode & 077)) {
+	$useReadOnlyPasswd="true";
+}
+else {
+	$useReadOnlyPasswd="false";	
+}
+
 # Find display number.
 
 if ((@ARGV > 0) && ($ARGV[0] =~ /^:(\d+)$/)) {
@@ -207,6 +220,10 @@
 }
 
 $vncPort = 5900 + $displayNumber;
+if($vncPort > 5949) {
+	die "Only port numbers below :49 (5949) are allowed\n";
+}
+$vncReadOnlyPort = 50 + $vncPort;
 
 $desktopLog = "$vncUserDir/$host:$displayNumber.log";
 unlink($desktopLog);
@@ -247,6 +264,12 @@
 $cmd .= " -rfbwait $rfbwait";
 $cmd .= " -rfbauth $vncPasswdFile";
 $cmd .= " -rfbport $vncPort";
+if ($useVncReadOnlyPort eq "true") {
+	$cmd .= " -readonlyport $vncReadOnlyPort";
+}
+if ($useReadOnlyPasswd eq "true") {
+	$cmd .= " -readonlyauth $vncPasswdFile.readonly";
+}
 $cmd .= ' -fp "' . $fontPath . '"';
 $cmd .= " -co $colorPath" if ($colorPath);
 $cmd .= " -alwaysshared" if ($opt{'-alwaysshared'});
